list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})
include(split_ver)
# following arguments are ready after this macro is called
# OG_PNAME
# OG_PVER
# OG_PNAME_FULL
# OG_DEPS: list of dep names
# OG_${depname}_VER
macro(og_read_dep)
set(OG_DEPS "")
set(OG_DEPFILE_PATH ${CMAKE_SOURCE_DIR}/versions.json)
file(READ ${OG_DEPFILE_PATH} DEPS_JSON_STRING)
string(JSON OG_PNAME
    GET ${DEPS_JSON_STRING} project_name)
#message("name : ${OG_PNAME}")
string(JSON OG_PVER
    GET ${DEPS_JSON_STRING} version)
og_split_ver(${OG_PVER} OG_PVER_MAJOR OG_PVER_MINOR OG_PVER_PATCH VERLEN)
#message("ver : ${OG_PVER}")
set(OG_PPREFIX ${OG_PNAME}-${OG_PVER})
set(OG_PTGTNAME ${OG_PNAME}-targets)
set(DEPS_ARRAY_ERR "")
string(JSON DEPS_ARRAY_STRING ERROR_VARIABLE DEPS_ARRAY_ERR GET
    ${DEPS_JSON_STRING} deps)
if (NOT ${DEPS_ARRAY_ERR} STREQUAL "NOTFOUND")
    message("[${OG_PNAME}] No dependencies...")
    set(NUM_OF_DEPS "0")
    set(OG_DEPS "")
else()
    string(JSON NUM_OF_DEPS
        LENGTH ${DEPS_ARRAY_STRING} )
    if (${NUM_OF_DEPS} GREATER_EQUAL 1)
    math(EXPR __OGKIT_DEPS_LOOP_ENDVAR "${NUM_OF_DEPS} - 1")
    foreach(BK_D_IDX RANGE ${__OGKIT_DEPS_LOOP_ENDVAR})
    string(JSON __OGKIT_CUR_DEP
        GET ${DEPS_ARRAY_STRING} ${BK_D_IDX})
    string(JSON __OGKIT_CUR_DEP_NAME
        GET ${__OGKIT_CUR_DEP} dep_name)
    string(JSON __OGKIT_CUR_DEP_VER
        GET ${__OGKIT_CUR_DEP} version)
    og_split_ver(${__OGKIT_CUR_DEP_VER} MAJOR MINOR PATCH VERLEN)
    #message("using ${__OGKIT_CUR_DEP_NAME}(${VERLEN}) ${MAJOR}:${MINOR}:${PATCH}")
    set(OG_DEP_${__OGKIT_CUR_DEP_NAME}_VER ${MAJOR}.${MINOR}.${PATCH})
    set(OG_DEP_${__OGKIT_CUR_DEP_NAME}_VER_MAJOR ${MAJOR})
    set(OG_DEP_${__OGKIT_CUR_DEP_NAME}_VER_MINOR ${MINOR})
    set(OG_DEP_${__OGKIT_CUR_DEP_NAME}_VER_PATCH ${PATCH})
    list(APPEND OG_DEPS ${__OGKIT_CUR_DEP_NAME})
endforeach()
endif()
message("[${OG_PNAME}](${OG_PVER}) all dependencies: ${OG_DEPS}")
foreach(__depname ${OG_DEPS})
	message("using ${__depname} ${OG_DEP_${__depname}_VER}")
endforeach()
endif()
endmacro()
