include_guard(GLOBAL)
macro(og_kit_init)
  set(OG_INSTALL_INCLUDE ON CACHE BOOL "whether include dir will be installed")
  set(OG_INSTALL_BUILDINFO ON CACHE BOOL "whether buildinfo dir will be installed")
  set(OG_BUILD_KIT_CMAKE_DIR ${CMAKE_CURRENT_LIST_DIR})
  set(DISTROOT ${OG_BUILD_KIT_CMAKE_DIR}/.. CACHE PATH "dist root dir")
  get_filename_component(DISTROOT ${DISTROOT} ABSOLUTE)
  #set(OG_CONDA_PREFIX ${OG_BUILD_KIT_CMAKE_DIR}/../conda)

	if(DEFINED OG_INITED)
		message(FATAL_ERROR "og_kit_init called more than once!")
	endif()
    if((NOT DEFINED CMAKE_BUILD_TYPE) OR (CMAKE_BUILD_TYPE STREQUAL ""))
        set(CMAKE_BUILD_TYPE Release)
    endif()
    message("Setting configuration to ${CMAKE_BUILD_TYPE}")
    #if(NOT EXISTS ${CMAKE_SOURCE_DIR}/versions.yaml)
    #message(FATAL_ERROR "${CMAKE_SOURCE_DIR}/versions.yaml does not exist. This is not a valid repo!")
    #endif()
    #TODO: .env files
    #list(APPEND CMAKE_CONFIGURE_DEPENDS ${CMAKE_SOURCE_DIR}/versions.yaml)
    include(og-project)
    include(og-target)
    include(og-util)
    include(og-testing)
	set(OG_INITED TRUE)

  # globals:
  # TODO
  set(OG_DEP_PKGS_LIST "")
endmacro()

# unused
# calling sequence: og_kit_init(),og_kit_reset()
macro(og_kit_reset)
    if (NOT DEFINED OG_INITED OR DEFINED OG_RESET)
        message(FATAL_ERROR "og_kit_init() should be called before og_kit_reset!")
    endif()
    #ogbk_reset()
    set(OG_RESET TRUE)
endmacro()

og_kit_init()
