# find_package helper
function(find_opt target version)
  set(${target}_ROOT ${DISTROOT}/${target}/${version})
  find_package(${target} REQUIRED)
  if (${target}_FOUND)
    message("find_opt:   [${target}-${version}] found.")
    include_directories(AFTER ${${target}_INCLUDE_DIR})
  endif()
  if (${target}_NOTFOUND)
    message(FATAL_ERROR "find_opt:   [${target}-${version}] NOT found!")
  endif()
endfunction()



#Globals: 
# OG_PTARGETS: list of og targets within the project
set_property(GLOBAL PROPERTY OG_PTARGETS "")
# OG_PTARGETS_NS: list of og targets within the project, with namespace
set_property(GLOBAL PROPERTY OG_PTARGETS_NS "")
function(og_add_target target)
    if(NOT TARGET ${target})
        message(FATAL_ERROR "${target} is not a target!")
    endif()
    if(NOT DEFINED OG_DEP_PKGS_LIST)
        message(FATAL_ERROR "OG_DEP_PKGS_LIST is not define! init have failed.")
    endif()
    # Disused. Making compiler flags a target means build kit have to populate
    # it to the config cmakefile (true?), which is difficult to undo if downstream want to
    # have some flags off
    if(FALSE)
    if(NOT TARGET ${OG_PNAME}_compiler_target)
        add_library(${OG_PNAME}_compiler_target INTERFACE)
        if (CMAKE_COMPILER_IS_GNUCXX)
        target_compile_options(${OG_PNAME}_compiler_target
            INTERFACE -Wall -Wextra -Werror)
        endif()
        install(TARGETS ${OG_PNAME}_compiler_target
            EXPORT ${OG_PTGTNAME})
    endif()
    endif()

    get_target_property(ttype ${target} TYPE)
    get_target_property(is_imported ${target} IMPORTED)
    if(${ttype} STREQUAL "STATIC_LIBRARY")
    elseif((${ttype} STREQUAL "SHARED_LIBRARY") OR (${ttype} STREQUAL "MODULE_LIBRARY"))
        target_link_libraries(${target} PRIVATE og_buildinfolib)
        #set_property(TARGET ${target} PROPERTY BUILD_RPATH_USE_ORIGIN TRUE)
    elseif(${ttype} STREQUAL "EXECUTABLE")
        target_link_libraries(${target} PRIVATE og_buildinfolib)
    elseif(${ttype} STREQUAL "INTERFACE_LIBRARY")
    else()
        message(FATAL_ERROR "target ${target} is of ${ttype} which can't be a og target")
    endif()
      if (NOT  ${is_imported})
        if(NOT ${ttype} STREQUAL "INTERFACE_LIBRARY")
          target_include_directories(${target}
              PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
              $<INSTALL_INTERFACE:${OG_PPREFIX}/include>)
          # TODO: NO_DEFAULT_COMPILE_OPTIONS
          if (CMAKE_COMPILER_IS_GNUCXX)
          target_compile_options(${target}
              PRIVATE -Wall -Wextra -Werror)
          endif()
          set_property(TARGET ${target} PROPERTY POSITION_INDEPENDENT_CODE ON)
      endif()
      install(TARGETS ${target}
          EXPORT ${OG_PTGTNAME} 
          ARCHIVE DESTINATION ${OG_PPREFIX}/lib$<$<CONFIG:DEBUG>:/debug>
          LIBRARY DESTINATION ${OG_PPREFIX}/lib$<$<CONFIG:DEBUG>:/debug>
          RUNTIME DESTINATION ${OG_PPREFIX}/bin$<$<CONFIG:DEBUG>:/debug>)
      else()
        get_target_property(import_loc ${target} IMPORTED_LOCATION)
        install(FILES ${import_loc}
           DESTINATION ${OG_PPREFIX}/lib)
      endif()
      foreach(depname ${OG_DEP_PKGS_LIST})
          foreach(deptarget ${${depname}_OG_TARGETS_NS})
              if(NOT TARGET ${deptarget})
              message(FATAL_ERROR "${deptarget} not a target!")
              endif()
              get_target_property(dt ${deptarget} TYPE)
              if(${dt} STREQUAL "STATIC_LIBRARY" OR ${dt} STREQUAL "SHARED_LIBRARY")
                  target_link_libraries(${target} PUBLIC ${deptarget})
              endif()
          endforeach()
      endforeach()
      get_property(TARGET_LIST GLOBAL PROPERTY OG_PTARGETS)
      list(APPEND TARGET_LIST ${target})
      set_property(GLOBAL PROPERTY OG_PTARGETS ${TARGET_LIST})
      get_property(TARGET_LIST_NS GLOBAL PROPERTY OG_PTARGETS_NS)
      list(APPEND TARGET_LIST_NS ${OG_PNAMESPACE}${target})
      set_property(GLOBAL PROPERTY OG_PTARGETS_NS ${TARGET_LIST_NS})
        #endif()
endfunction()
