macro(og_enable_testing)

#cmake_path
cmake_minimum_required(VERSION 3.20)

include(CTest)
configure_file(${OG_BUILD_KIT_CMAKE_DIR}/in/catch2_main.cpp.in ${PROJECT_SOURCE_DIR}/test/catch2_main.cpp)
enable_testing()

function(og_add_test)
  set(test_source_path ${ARGV0})
  cmake_parse_arguments(
    PARSE_ARGV 1
    TEST
    ""
    ""
    "LIBS")
  cmake_path(GET test_source_path STEM test_target_var)
  get_filename_component(test_target_var ${test_source_path} NAME_WE)
  add_executable(${test_target_var} ${test_source_path}
    ${PROJECT_SOURCE_DIR}/test/catch2_main.cpp)
  if(DEFINED TEST_LIBS)
    target_link_libraries(${test_target_var}
      PUBLIC ${TEST_LIBS})
  endif()
  target_include_directories(${test_target_var} AFTER
    PUBLIC ${PROJECT_SOURCE_DIR}/test)
  set_target_properties(${test_target_var}
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/test)
  add_test(NAME ${test_target_var} COMMAND ${test_target_var})
endfunction()
endmacro()
