#pragma once
#include <linalg/type.hpp>
// No assumption on whether knots/x is sorted
Eigen::ArrayXi lower_bound_index(const dynvec_t& x, const dynvec_t& knots);
dynmat_t natural_f(dynvec_t knots);
dynmat_t get_free_crs_dmat(dynvec_t x, dynvec_t knots, dynmat_t f, int deriv_order);

struct spline_base_t {
  Eigen::ArrayXd ajm, ajp, cjm, cjp;
  Eigen::ArrayXi j;
};
spline_base_t compute_base_functions(const dynvec_t& x, const dynvec_t& knots, int deriv_order);

/* using default cost/dcost and constraints.
 * */
struct volfit_iarray_t {
  // all array are allocated by constructor, user shall then fill in the correct input values.
  explicit volfit_iarray_t(int num_fitdata, int num_knots);
  ~volfit_iarray_t();
  int num_fitdata;
  int num_knots;
  double* fitdata_x;
  double* fitdata_values;
  double* fitdata_weights;
  double* knots;
  double* x0;
};
