#include "pcommon/ttm.hpp"
#include <optional>
namespace pricer {
struct ttm_clock_impl_t {
  ttm_init_t::pointer_type input;
  std::optional<tp::tp_t> last_tick_;
  explicit ttm_clock_impl_t(ttm_init_t::pointer_type i): input(i) {}
};

ttm_clock_t::ttm_clock_t(ttm_init_t::pointer_type init):
  pimpl_(std::make_unique<ttm_clock_impl_t>(init)) {
}

struct fixed_discount_ttm_t : public ttm_clock_t {
  explicit fixed_discount_ttm_t(ttm_init_t::pointer_type i): 
    ttm_clock_t(i),
    init_(*dynamic_cast<fixed_discount_ttm_init_t*>(i.get())),
    dc_(init_.discount) {
  }

  void on_timer(tp::tp_t t) override {
    const bool init_tick = !pimpl_->last_tick_;
    pimpl_->last_tick_ = t;
    if (init_tick) {
    }
  }

  void on_param_update() override {
  }

  void add_term(option_term&) override {
  }

  private:
  fixed_discount_ttm_init_t& init_;
  double dc_;
};

ttm_clock_t::pointer_type ttm_clock_t::make(ttm_init_t::pointer_type i) {
  if (!i) {
    return nullptr;
  }
  if (i->method == fixed_discount_ttm_init_t::METHOD) {
    auto di = dynamic_cast<fixed_discount_ttm_init_t*>(i.get());
  }
  return nullptr;
}
} // namespace pricer
