#include "linalg/type.hpp"
#include <catch2/catch.hpp>
#include <fit/crs.hpp>
#include <optmz/minmz.hpp>

using namespace Eigen;
TEST_CASE("less strike") {
  dynvec_t N(7);
  N << -0.1, -0.05, -0.022, 0.0, 0.022, 0.05, 0.1;
  constexpr size_t NUMX = 6;
  dynvec_t Fx(NUMX), Fy(NUMX);
  Fx << -0.6, -0.3, -0.1, 0.022, 0.4, 0.7;
  Fy << 20.0, 17.0, 17.5, 15.0, 17.0, 18.3;
  auto basis = get_free_crs_dmat(Fx, N, natural_f(N), 0);
  auto basis_d1 = get_free_crs_dmat(Fx, N, natural_f(N), 1);
  auto basis_d2 = get_free_crs_dmat(Fx, N, natural_f(N), 2);

  minimz_i_t input_no_butterfly;
  // input_no_butterfly.func = ;
  input_no_butterfly.func = [](dynvec_t coef) -> double {
		return 0.;
	};
	input_no_butterfly.jac = [](dynvec_t coef) -> dynvec_t {
    return dynvec_t{};
	};
	input_no_butterfly.ftol = 1e-6;
  slsqp_ws_t res_no_butterfly{std::move(input_no_butterfly)};
	res_no_butterfly.minimize();
}
