#include <catch2/catch.hpp>
#include <stdio.h>
#include <stdlib.h>
#include "cslsqp.h"

TEST_CASE("fortran with dummy data") {
  int M = 10, MEQ = 5;
  int LA = 15;
  int N = 1;
  double *X = (double *)malloc(sizeof(double) * N);
  double *XL = (double *)malloc(sizeof(double) * N);
  double *XU = (double *)malloc(sizeof(double) * N);
  double F = 10.0;
  double *C = (double *)malloc(sizeof(double) * LA);
  double *G = (double *)malloc(sizeof(double) * (N + 1));
  double *A = (double *)malloc(sizeof(double) * (N + 1) * (LA));
  double ACC = 1.0;
  int ITER = 1000;
  int MODE = 0;
  int N1 = N + 1;
  int L_W = (3 * (N1) + M) * (N1 + 1) + 54;
  int L_JW = 54010;
  double *W = (double *)malloc(sizeof(double) * L_W);
  int *JW = (int *)malloc(sizeof(int) * L_JW);

  double alpha, f0, gs, h1, h2, h3, h4, t, t0, to1;
  int iexact, incons, ireset, itermx, line, n1, n2, n3;
  cslsqp(&M, &MEQ, &LA, &N, X, XL, XU, &F, C, G, A, &ACC, &ITER, &MODE, W, &L_W,
         JW, &L_JW, &alpha, &f0, &gs, &h1, &h2, &h3, &h4, &t, &t0, &to1,
         &iexact, &incons, &ireset, &itermx, &line, &n1, &n2, &n3);

  printf("mode:%d \n", MODE);
}
